package com.mideaepay.demo.main;

import java.io.File;
import java.io.IOException;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.naming.NamingException;
import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.webapp.WebAppContext;
import org.eclipse.jetty.xml.XmlConfiguration;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * @author kanbo
 */
public class JettyStarter {
    
    public static void main(String[] args) throws IOException, NamingException, SQLException, ClassNotFoundException {
        startJetty();
    }
    
    public static void startJetty() throws NamingException, SQLException {
        try {
            Server server = new Server();
            ClassLoader cl = Thread.currentThread().getContextClassLoader();
            Properties p = new Properties(System.getProperties());
            p.load(cl.getResourceAsStream("config.properties"));
            XmlConfiguration xmlConfig = new XmlConfiguration(cl.getResourceAsStream("jetty.xml"));
            Map<String, String> props = new HashMap<>();
            for (Object key : p.keySet()) {
                props.put(key.toString(), String.valueOf(p.get(key)));
            }
            xmlConfig.getProperties().putAll(props);
            xmlConfig.configure();
            xmlConfig.configure(server);
            
            WebAppContext webAppContext = new WebAppContext();
            File webappFile = new File("./webapp/");
            if (!webappFile.exists()) {
                webappFile = new File("../webapp/");
            }
            if (!webappFile.exists()) {
                throw new Exception("webapp path is wrong!");
            }
            webAppContext.setResourceBase(webappFile.getCanonicalPath());
            webAppContext.setContextPath("/");
            server.setHandler(webAppContext);
            server.start();
            server.join();
        } catch (Exception e) {
            System.out.println(e);
            System.exit(0);
        }
    }
    
}
