package com.mideaepay.demo.service.impl.b2c;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import com.alibaba.fastjson.JSONObject;
import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.TradeUtils;
import com.mideaepay.demo.utils.Constant.Key;
import com.mideaepay.demo.utils.Constant.Service;
import com.mideaepay.demo.utils.WebUtils;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * @desc <B2C-收银台-合单>
 * @author kanbo
 * @date 2020-9-2 12:21:13
 */
@ServiceAnnotation(service = Service.BATCH_TRADE_PAY_CASHIER,httpForm = true)
public class BatchTradePayCashierService extends AbstractGateWayService {
    
    @Override
    protected void setCustomConfigPath() {

    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {
        params.put(Key.VERSION, "3.2.0");
        params.put(Key.TERMINAL_TYPE, "PC");
        // 页面回调地址,商户传入自己的地址
        params.put(Key.RETURN_URL, commonProperties.getProperty("return_url"));
        // 商户异步通知地址,商户传入自己的地址
        params.put(Key.NOTIFY_URL, commonProperties.getProperty("notify_url"));
        // 及时到账传FLASE,担保交易传TRUE
        params.put(Key.IS_GUARANTEE, "FALSE");
        params.put(Key.TOKEN, "");
        params.put(Key.TOKEN_TIME, "");
        // 商户订单号，此处实现不能保证唯一性，需商户自己实现
        params.put(Key.OUT_TRADE_NO, TradeUtils.getOutTradeNo());
        params.put(Key.OUT_TRADE_TIME, TradeUtils.getOutTradeTime());
        params.put(Key.PAYER_TYPE, "");
        params.put(Key.PAYER_PAY_TYPE, "");
        params.put(Key.PAYER_LOGIN_NAME, "");
        params.put(Key.OUT_USER_ACCOUNT, "");
        params.put(Key.CURRENCY_TYPE, commonProperties.getProperty("currency_type"));
        params.put(Key.LIMIT_ACCT_TYPE, "DOC");
        params.put(Key.PAY_EXPIRE_TIME, "30");
        params.put(Key.IS_VIRTUAL_PRODUCT, "FALSE");
        params.put(Key.PRODUCT_NAME, "美的到家-空调");
        params.put(Key.PRODUCT_INFO, "换新风无风感1.5匹一级能效");
        params.put(Key.ATTACH, "商户附言");
        params.put(Key.PARTNER_APP_ID, "");
        params.put(Key.OPEN_ID, "");
        params.put(Key.RETURN_SCRIPT, "");
        params.put(Key.SESSION_ID, "");
        params.put(Key.RISK_PARAMS, "{\"ip\":\"" + WebUtils.getRemoteIp(request) + "\"}");
        params.put(Key.BUSINESS_NO, "");
        setSubOrders(params);
    }
    
    private void setSubOrders(Map<String, String> parameters) {
        List<Map<String, Object>> subOrderList = new ArrayList<Map<String, Object>>();
        int subOrderCount = 2;
        int payAomunt = 30;
        for (int i = 0; i < subOrderCount; i++) {
            Map<String, Object> subOrder = new HashMap<>();
            subOrder.put(Key.PARTNER, commonProperties.get("partner"));
            subOrder.put(Key.SUB_OUT_TRADE_NO, TradeUtils.getOutTradeNo());
            subOrder.put(Key.PAY_AMOUNT, String.valueOf(payAomunt));
            subOrder.put(Key.SUB_PRODUCT_NAME, "商品名称");
            subOrder.put(Key.SUB_PRODUCT_INFO, "商品信息");
            subOrder.put(Key.SUB_PRODUCT_COUNT, "2");
            subOrder.put(Key.SUB_PRODUCT_PRICE, "10");
            subOrder.put(Key.SUB_TRADE_PURPOSE, "");
            subOrder.put(Key.SUB_ATTACH, "sub_attach");
            subOrder.put(Key.PROFIT_PARAMS, "");
            subOrder.put(Key.PROFIT_SHARING, "FALSE");
            subOrderList.add(subOrder);
        }
        
        parameters.put(Key.SUB_ORDERS, JSONObject.toJSONString(subOrderList));
        parameters.put(Key.TOTAL_COUNT, String.valueOf(subOrderCount));
        parameters.put(Key.TOTAL_AMOUNT, String.valueOf(subOrderCount*payAomunt));
    }
    
}
