package com.mideaepay.demo.service.impl.b2c;

import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.TradeUtils;
import com.mideaepay.demo.utils.Constant.Service;
import com.mideaepay.demo.utils.WebUtils;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * @desc <B2C-支付宝-单笔>
 * @author kanbo
 * @date 2020-9-1 12:21:13
 */
@ServiceAnnotation(service = Service.TRADE_PAY_ALIPAY)
public class TradePayAliPayService extends AbstractGateWayService {
    
    @Override
    protected void setCustomConfigPath() {
    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {
        params.put("version", "3.2.0");
        params.put("terminal_type", "ITG");
        //商户异步通知地址,商户传入自己的地址
        params.put("notify_url", commonProperties.getProperty("notify_url"));
        //及时到账传FLASE,担保交易传TRUE
        params.put("is_guarantee", "FALSE");
        //商户订单号，此处实现不能保证唯一性，需商户自己实现
        params.put("out_trade_no", TradeUtils.getOutTradeNo());
        params.put("out_trade_time", TradeUtils.getOutTradeTime());
        
        params.put("payer_type", "");
        params.put("payer_login_name", "");
        params.put("payee_login_name", "");
        params.put("bar_code", "APP");
        params.put("open_id", "");
        params.put("currency_type", commonProperties.getProperty("currency_type"));
        //交易金额,单位: 分
        params.put("pay_amount", "100");
        params.put("limit_acct_type", "DOC");
        params.put("pay_expire_time", "30");
        params.put("is_virtual_product", "FALSE");
        params.put("product_name", "美的到家-空调");
        params.put("product_info", "换新风无风感1.5匹一级能效");
        params.put("product_count", "2");
        //商品单价,单位: 分
        params.put("product_price", "19");
        params.put("trade_purpose", "");
        params.put("attach", "商户附言");
        params.put("risk_params", "{\"ip\":\""+WebUtils.getRemoteIp(request)+"\"}");
        params.put("profit_params", "");
        params.put("profit_sharing", "FALSE");

    }
    
}
