package com.mideaepay.demo.service.impl.b2c;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.TradeUtils;
import com.mideaepay.demo.utils.WebUtils;
import com.mideaepay.demo.utils.Constant.Service;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * @desc <b2c-退款>
 * @author kanbo  
 * @date 2020-9-6 17:01:16
 */
@ServiceAnnotation(service = Service.TRADE_REFUND)
public class TradeRefundService extends AbstractGateWayService {

    @Override
    protected void setCustomConfigPath() {
        customConfigPath = "config/b2c/trade_refund.properties";
    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {
        params.put("terminal_type", "ITG");
        //商户异步通知地址,商户传入自己的地址
        params.put("notify_url", commonProperties.getProperty("notify_url"));
        //商户订单号，此处实现不能保证唯一性，需商户自己实现
        params.put("out_refund_no", TradeUtils.getOutTradeNo());
        params.put("out_refund_time", TradeUtils.getOutTradeTime());
        params.put("out_trade_no", customProperties.getProperty("out_trade_no"));
        params.put("refund_amount", "1");
        params.put("currency_type", commonProperties.getProperty("currency_type"));
        params.put("attach", "商户附言");
        params.put("risk_params", "{\"ip\":\""+WebUtils.getRemoteIp(request)+"\"}");
    }
    
}
