package com.mideaepay.demo.service.impl.data;

import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.Constant;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * 电子回单下载
 *
 * @author harvey
 * @date 2020/12/2
 * @email husy7@midea.com
 */
@ServiceAnnotation(service = Constant.Service.DATA_DOWNLOAD_RECEIPT)
public class DataDownloadReceiptService extends AbstractGateWayService{

    @Override
    protected void setCustomConfigPath() {

        customConfigPath = "config/data/data_download_receipt.properties";

    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {

        params.put("terminal_type", commonProperties.getProperty("terminal_type"));
        params.put("query_type", customProperties.getProperty("query_type"));
        params.put("order_type", customProperties.getProperty("order_type"));
        params.put("query_partner", customProperties.getProperty("query_partner"));
        params.put("query_start_time", customProperties.getProperty("query_start_time"));
        params.put("query_end_time", customProperties.getProperty("query_end_time"));
        params.put("notify_url", customProperties.getProperty("notify_url"));
        params.put("trade_no", customProperties.getProperty("trade_no"));

    }
}
