package com.mideaepay.demo.service.impl.data;

import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.Constant;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * 解绑银行卡
 *
 * @author harvey
 * @date 2020/12/3
 * @email husy7@midea.com
 */
@ServiceAnnotation(service = Constant.Service.DATA_USER_CARD_UNBIND)
public class DataUserCardUnbindService extends AbstractGateWayService{

    @Override
    protected void setCustomConfigPath() {

        customConfigPath = "config/data/data_user_card_unbind.properties";

    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {

        params.put("token", customProperties.getProperty("token"));
        params.put("token_time", customProperties.getProperty("token_time"));
        params.put("return_url", customProperties.getProperty("return_url"));
        params.put("login_name", customProperties.getProperty("login_name"));
        params.put("bind_no", customProperties.getProperty("bind_no"));
        params.put("ip", customProperties.getProperty("ip"));
        params.put("mac", customProperties.getProperty("mac"));
        params.put("imei", customProperties.getProperty("imei"));
        params.put("device_version", customProperties.getProperty("device_version"));
        params.put("cpu_info", customProperties.getProperty("cpu_info"));
        params.put("longitude", customProperties.getProperty("longitude"));
        params.put("latitude", customProperties.getProperty("latitude"));
        params.put("imsi", customProperties.getProperty("imsi"));
        params.put("iccid", customProperties.getProperty("iccid"));
        params.put("wifi_mac", customProperties.getProperty("wifi_mac"));
    }
}
