package com.mideaepay.demo.service.impl.data;

import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.Constant;
import com.mideaepay.demo.utils.SignUtils;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * 绑卡发送短信
 *
 * @author harvey
 * @date 2020/12/3
 * @email husy7@midea.com
 */
@ServiceAnnotation(service = Constant.Service.DATA_USER_CARDBIND_PREPARE)
public class DataUserCardbinPrepareService extends AbstractGateWayService{

    @Override
    protected void setCustomConfigPath() {

        customConfigPath = "config/data/data_user_cardbin_prepare.properties";

    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {

        params.put("login_name", customProperties.getProperty("login_name"));
        params.put("real_name", customProperties.getProperty("real_name"));
        params.put("cert_type", customProperties.getProperty("cert_type"));
        params.put("cert_no", SignUtils
            .partnerAesEncrypt(customProperties.getProperty("cert_no"), commonProperties.getProperty("partner"),
                params.get("req_seq_no"), commonProperties.getProperty("partner_key")));
        params.put("bank_card", SignUtils
            .partnerAesEncrypt(customProperties.getProperty("bank_card"), commonProperties.getProperty("partner"),
                params.get("req_seq_no"), commonProperties.getProperty("partner_key")));
        params.put("mobile_no", SignUtils
            .partnerAesEncrypt(customProperties.getProperty("mobile_no"), commonProperties.getProperty("partner"),
                params.get("req_seq_no"), commonProperties.getProperty("partner_key")));
    }

}
