package com.mideaepay.demo.service.impl.data;

import com.alibaba.fastjson.JSONObject;
import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.Constant;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.Map;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * 请求支付密码校验页面
 *
 * @author harvey
 * @date 2020/12/3
 * @email husy7@midea.com
 */
@ServiceAnnotation(service = Constant.Service.DATA_USER_PAYPWD_CHECK)
public class DataUserPaypwdCheckService extends AbstractGateWayService{

    @Override
    protected void setCustomConfigPath() {

        customConfigPath = "config/data/data_user_paypwd_check.properties";

    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {

        params.put("terminal_type", customProperties.getProperty("terminal_type"));
        params.put("login_name", customProperties.getProperty("login_name"));
        params.put("token_time", customProperties.getProperty("token_time"));
        params.put("token", customProperties.getProperty("token"));
        params.put("session_id", customProperties.getProperty("session_id"));
        params.put("return_type", customProperties.getProperty("return_type"));
        params.put("return_url", customProperties.getProperty("return_url"));
        params.put("return_script", customProperties.getProperty("return_script"));
        params.put("cause", customProperties.getProperty("login_name"));

        Map<String, String> riskParams = new HashMap<>();
        riskParams.put("ip", customProperties.getProperty("ip"));
        riskParams.put("mac", customProperties.getProperty("mac"));
        riskParams.put("imei", customProperties.getProperty("imei"));
        riskParams.put("device_version", customProperties.getProperty("device_version"));
        riskParams.put("cpu_info", customProperties.getProperty("cpu_info"));
        riskParams.put("longitude", customProperties.getProperty("longitude"));
        riskParams.put("latitude", customProperties.getProperty("latitude"));
        riskParams.put("imsi", customProperties.getProperty("imsi"));
        riskParams.put("iccid", customProperties.getProperty("iccid"));
        riskParams.put("wifi_mac", customProperties.getProperty("wifi_mac"));
        params.put("risk_param", JSONObject.toJSONString(riskParams));

    }
}
