package com.mideaepay.demo.service.impl.data;

import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.Constant;
import com.mideaepay.demo.utils.SignUtils;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * 用户实名认证
 *
 * @author harvey
 * @date 2020/12/3
 * @email husy7@midea.com
 */
@ServiceAnnotation(service = Constant.Service.DATA_USER_REALNAME_AUTH)
public class DataUserRealnameAuthService extends AbstractGateWayService{

    @Override
    protected void setCustomConfigPath() {

        customConfigPath = "config/data/data_user_realname_auth.properties";

    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {

        params.put("login_name", customProperties.getProperty("login_name"));
        params.put("real_name", customProperties.getProperty("real_name"));
        params.put("mobile", SignUtils
            .partnerAesEncrypt(customProperties.getProperty("mobile"), commonProperties.getProperty("partner"),
                params.get("req_seq_no"), commonProperties.getProperty("partner_key")));
        params.put("cert_type", customProperties.getProperty("cert_type"));
        params.put("cert_no", SignUtils
            .partnerAesEncrypt(customProperties.getProperty("cert_no"), commonProperties.getProperty("partner"),
                params.get("req_seq_no"), commonProperties.getProperty("partner_key")));
        params.put("validity_date", customProperties.getProperty("expire_date"));
        params.put("expire_date", customProperties.getProperty("expire_date"));
        params.put("occupation", customProperties.getProperty("occupation"));
        params.put("area", customProperties.getProperty("area"));
        params.put("address", customProperties.getProperty("address"));
    }
}
