package com.mideaepay.demo.service.impl.distribute;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.Constant.Service;
import com.mideaepay.demo.utils.TradeUtils;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * 批量代付
 *
 * @author harvey
 * @date 2020/8/31
 * @email husy7@midea.com
 */
@ServiceAnnotation(service = Service.BATCH_DISTRIBUTE_PAY)
public class BatchDistributePayService extends AbstractGateWayService{

    @Override
    protected void setCustomConfigPath() {

        customConfigPath = "config/distribute/batch_distribute_pay.properties";
    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {

        params.put("out_trade_no", TradeUtils.getOutTradeNo());
        params.put("out_trade_time", TradeUtils.getOutTradeTime());
        params.put("notify_url", commonProperties.getProperty("notify_url"));
        params.put("total_amount", customProperties.getProperty("total_amount"));
        params.put("total_count", customProperties.getProperty("total_count"));
        params.put("currency_type", commonProperties.getProperty("currency_type"));
        params.put("attach", customProperties.getProperty("attach"));

        String sub_orders = customProperties.getProperty("sub.orders");
        List<Map<String, String>> maps = JSONObject
            .parseObject(sub_orders, new TypeReference<List<Map<String, String>>>(){

            });

        for (Map<String, String> map : maps) {

            map.put("sub_out_trade_no", TradeUtils.getOutTradeNo());
            map.put("notify_mobile", TradeUtils
                .aesEncode(params, (String) map.get("notify_mobile"), customProperties.getProperty("partner.key")));
            if ("CARD".equals(map.get("trade_type"))) {
                map.put("payee_bank_acct_no", TradeUtils.aesEncode(params, (String) map.get("payee_bank_acct_no"),
                    customProperties.getProperty("partner.key")));
            }
        }
        params.put("sub_orders", JSONObject.toJSONString(maps));
    }

}
