package com.mideaepay.demo.service.impl.distribute;

import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.Constant.Service;
import com.mideaepay.demo.utils.DigestUtils;
import com.mideaepay.demo.utils.FileUtils;
import com.mideaepay.demo.utils.TradeUtils;

import java.io.File;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * 报盘代付
 *
 * @author harvey
 * @date 2020/8/31
 * @email husy7@midea.com
 */
@ServiceAnnotation(service = Service.BATCH_FILE_DISTRIBUTE_PAY)
public class BatchFileDistributePayService extends AbstractGateWayService{

    @Override
    protected void setCustomConfigPath() {

        customConfigPath = "config/distribute/batch_file_distribute_pay.properties";
    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {

        params.put("out_trade_no", customProperties.getProperty("out_trade_no"));
        params.put("out_trade_time", TradeUtils.getOutTradeTime());
        params.put("notify_url", commonProperties.getProperty("notify_url"));
        params.put("total_amount", customProperties.getProperty("total_amount"));
        params.put("total_count", customProperties.getProperty("total_count"));
        params.put("currency_type", commonProperties.getProperty("currency_type"));
        params.put("payer_act_type", customProperties.getProperty("payer_act_type"));
        params.put("attach", customProperties.getProperty("attach"));
        //计算文件的md5值
        File file = new File(customProperties.getProperty("filePath"));
        String fileMd5 = DigestUtils.md5DigestAsHex(FileUtils.file2byte(file));
        params.put("file_md5", fileMd5);

        super.file = file;
    }

}
