package com.mideaepay.demo.service.impl.distribute;

import com.alibaba.fastjson.JSON;
import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.Constant.Service;
import com.mideaepay.demo.utils.TradeUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * 多级代付
 *
 * @author harvey
 * @date 2020/8/31
 * @email husy7@midea.com
 */
@ServiceAnnotation(service = Service.DISTRIBUTE_MULTI_PAY)
public class DistributeMultiPayService extends AbstractGateWayService{

    @Override
    protected void setCustomConfigPath() {

        customConfigPath = "config/distribute/distribute_multi_pay.properties";
    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {

        params.put("out_trade_no", TradeUtils.getOutTradeNo());
        params.put("out_trade_time", TradeUtils.getOutTradeTime());
        params.put("notify_url", commonProperties.getProperty("notify_url"));
        params.put("total_count", customProperties.getProperty("total_count"));
        params.put("currency_type", commonProperties.getProperty("currency_type"));
        params.put("attach", customProperties.getProperty("attach"));
        params.put("project_no", customProperties.getProperty("project_no"));

        params.put("multi_details", JSON.toJSONString(getOrderList(params)));

    }

    private List<Map<String, Object>> getOrderList(Map<String, String> reqMap) {

        List<Map<String, Object>> orderList = new ArrayList<>();

        Map<String, Object> balanceMap1 = new HashMap<>();
        balanceMap1.put("trade_type", "BALANCE");
        balanceMap1.put("sub_out_trade_no", TradeUtils.getOutTradeNo());
        balanceMap1.put("payer_partner", "1010082102");
        balanceMap1.put("payer_project_flag", "NO");
        balanceMap1.put("payee_login_name", "1010039999");
        balanceMap1.put("payee_type", "B");
        balanceMap1.put("payee_project_flag", "YES");
        balanceMap1.put("payee_name", "马庆六-测试商户");
        balanceMap1.put("pay_amount", "5");
        balanceMap1.put("sub_attach", "sub_attach1");
        balanceMap1.put("notify_mobile",
            TradeUtils.aesEncode(reqMap, "13551240710", customProperties.getProperty("partner.key")));
        balanceMap1.put("multi_details", (getBalanceListL2()));
        orderList.add(balanceMap1);

        Map<String, Object> cardMap = new HashMap<>();
        cardMap.put("trade_type", "CARD");
        cardMap.put("sub_out_trade_no", TradeUtils.getOutTradeNo());
        cardMap.put("payer_partner", "1010082102");
        cardMap.put("payer_project_flag", "NO");
        cardMap.put("payee_bank_acct_no",
            TradeUtils.aesEncode(reqMap, "383828373822837", customProperties.getProperty("partner.key")));
        cardMap.put("payee_name", "测试");
        cardMap.put("payee_acct_type", "PUBLIC_ACCT");
        cardMap.put("payee_sub_bank_name", "成都支行");
        cardMap.put("payee_sub_bank_code", "102611010336");
        cardMap.put("replace_name", "replace_name1");
        cardMap.put("bank_attach", "bank_attach1");
        cardMap.put("pay_amount", "2");
        cardMap.put("sub_attach", "sub_attach2");
        orderList.add(cardMap);

        return orderList;
    }

    private List<Map<String, Object>> getBalanceListL2() {

        List<Map<String, Object>> balanceList = new ArrayList<>();

        Map<String, Object> balanceMap11 = new HashMap<>();
        balanceMap11.put("trade_type", "BALANCE");
        balanceMap11.put("sub_out_trade_no", TradeUtils.getOutTradeNo());
        balanceMap11.put("payee_login_name", "1010084201");
        balanceMap11.put("payee_type", "B");
        balanceMap11.put("payee_project_flag", "NO");
        balanceMap11.put("payee_name", "胡思扬UAT测试商户");
        balanceMap11.put("pay_amount", "1");
        balanceMap11.put("sub_attach", "sub_attach11");
        balanceList.add(balanceMap11);

        Map<String, Object> balanceMap12 = new HashMap<>();
        balanceMap12.put("trade_type", "BALANCE");
        balanceMap12.put("sub_out_trade_no", TradeUtils.getOutTradeNo());
        balanceMap12.put("payee_login_name", "18711111111");
        balanceMap12.put("payee_type", "C");
        balanceMap12.put("payee_project_flag", "NO");
        balanceMap12.put("payee_name", "张三");
        balanceMap12.put("pay_amount", "2");
        balanceMap12.put("sub_attach", "sub_attach12");
        balanceList.add(balanceMap12);

        return balanceList;
    }

}
