package com.mideaepay.demo.service.impl.distribute;

import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.Constant;
import com.mideaepay.demo.utils.TradeUtils;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * 单笔代付
 *
 * @author harvey
 * @date 2020/9/2
 * @email husy7@midea.com
 */
@ServiceAnnotation(service = Constant.Service.DISTRIBUTE_PAY)
public class DistributePayService extends AbstractGateWayService{

    @Override
    protected void setCustomConfigPath() {

        customConfigPath = "config/distribute/distribute_pay.properties";
    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {

        params.put("notify_url", commonProperties.getProperty("notify_url"));
        params.put("pay_amount", customProperties.getProperty("pay_amount"));
        params.put("attach", customProperties.getProperty("attach"));
        params.put("payer_act_type", customProperties.getProperty("parer_acy_type"));
        params.put("trade_type", customProperties.getProperty("trade_type"));
        params.put("out_trade_no", TradeUtils.getOutTradeNo());
        params.put("out_trade_time", TradeUtils.getOutTradeTime());
        params.put("notify_mobile", TradeUtils.aesEncode(params, customProperties.getProperty("notify_mobile"),
            customProperties.getProperty("partner.key")));

        if ("BALANCE".equals(customProperties.getProperty("trade_type"))) {
            params.put("payee_login_name", customProperties.getProperty("payee_login_name"));
            params.put("payee_type", customProperties.getProperty("payee_type"));
            params.put("payee_name", customProperties.getProperty("payee_name"));
            params.put("bank_attach", customProperties.getProperty("bank_attach"));
        } else {
            params.put("payee_bank_acct_no", TradeUtils
                .aesEncode(params, customProperties.getProperty("payee_bank_acct_no"),
                    customProperties.getProperty("partner.key")));
            params.put("payee_name", customProperties.getProperty("payee_name"));
            params.put("payee_acct_type", customProperties.getProperty("payee_acct_type"));
            params.put("payee_acct_province", customProperties.getProperty("payee_acct_province"));
            params.put("payee_acct_city", customProperties.getProperty("payee_acct_city"));
            params.put("payee_sub_bank_name", customProperties.getProperty("payee_sub_bank_name"));
            params.put("payee_sub_bank_code", customProperties.getProperty("payee_sub_bank_code"));
            params.put("replace_name", customProperties.getProperty("replace_name"));
            params.put("bank_attach", customProperties.getProperty("bank_attach"));
        }
    }

}
