package com.mideaepay.demo.service.impl.distribute;

import com.mideaepay.demo.service.AbstractGateWayService;
import com.mideaepay.demo.service.ServiceAnnotation;
import com.mideaepay.demo.utils.Constant.Service;
import com.mideaepay.demo.utils.TradeUtils;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * 资金释放支付
 *
 * @author harvey
 * @date 2020/8/31
 * @email husy7@midea.com
 */
@ServiceAnnotation(service = Service.PROJECT_ACT_RELEASE)
public class ProjectActReleaseService extends AbstractGateWayService{

    @Override
    protected void setCustomConfigPath() {

        customConfigPath = "config/distribute/project_act_release.properties";
    }

    @Override
    protected void initBusinessRequest(Map<String, String> params, HttpServletRequest request) {

        params.put("out_trade_no", TradeUtils.getOutTradeNo());
        params.put("out_trade_time", TradeUtils.getOutTradeTime());
        params.put("terminal_type", customProperties.getProperty("terminal_type"));
        params.put("release_partner", customProperties.getProperty("release_partner"));
        params.put("project_no", customProperties.getProperty("project_no"));
        params.put("release_amount", customProperties.getProperty("release_amount"));
        params.put("attach", customProperties.getProperty("attach"));
        params.put("currency_type", commonProperties.getProperty("currency_type"));

    }

}
