package com.mideaepay.demo.servlet;

import java.io.IOException;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.mideaepay.demo.service.GatewayService;
import com.mideaepay.demo.service.GatewayServiceFactory;
import com.mideaepay.demo.utils.Constant.Key;
import com.mideaepay.demo.utils.WebUtils;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * @desc <servlet入口>
 * @author kanbo
 * @date 2020-9-1 12:20:47
 */
public class GatewayServlet extends HttpServlet {
    
    private static final long serialVersionUID = 738898423275116876L;
    
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doBusiness(req, resp);
    }
    
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doBusiness(req, resp);
    }
    
    private void doBusiness(HttpServletRequest req, HttpServletResponse resp) {
        // 获取入参
        Map<String, String> paramMap = WebUtils.getRequestParamsMap(req);
        // 获取处理类
        GatewayService gatewayService = GatewayServiceFactory.getInstance().produce(paramMap.get(Key.SERVICE));
        // 调用美的支付并返回响应数据
        gatewayService.service(req, resp);
    }
    
}
