package com.mideaepay.demo.utils;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.util.*;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * 配置文件管理
 * @author wangnan5
 *
 */
public class ConfigStatic {
    
    /**
     * 公共配置信息
     */
    protected static Properties commonProperties;
    
    /**
     * 公共配置文件路径
     */
    protected static String commonConfigPath = "config/common_config.properties";
    
    private ConfigStatic() {
    
    }
    
    static {
        //加载公共配置信息
        ClassLoader cl = Thread.currentThread().getContextClassLoader();
        commonProperties = new Properties(System.getProperties());

        try {
            commonProperties.load(new BufferedReader(
                new InputStreamReader(Objects.requireNonNull(cl.getResourceAsStream(commonConfigPath)),
                    StandardCharsets.UTF_8)));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    /**
     * 获取config配置文件的value
     * 
     * @param propertyName
     * @return
     */
    public static String getConfigProperty(String propertyName) {
        return commonProperties.getProperty(propertyName);
    }
    
}
