package com.mideaepay.demo.utils;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 * 交易工具类
 * @author harvey
 * @date 2020/9/2
 * @email husy7@midea.com
 */
public class TradeUtils{
    
    private static AtomicInteger idGen = new AtomicInteger(1);

    /**
     * 根据商户交易信息对数据加密
     * @param params
     * @param decodeValue
     * @param partnerKey
     * @return
     */
    public static String aesEncode(Map<String, String> params, String decodeValue, String partnerKey) {

        StringBuilder sb = new StringBuilder();
        sb.append("out_trade_no=").append(params.get("out_trade_no")).append("&out_trade_time=")
            .append(params.get("out_trade_time")).append("&partner=").append(params.get("partner"))
            .append("&req_seq_no=").append(params.get("req_seq_no")).append("&key=").append(partnerKey);

        String md5To16 = DigestUtils.getMD5String(sb.toString()).substring(8, 24).toLowerCase();

        byte[] bytes = DigestUtils.aesEncrypt(decodeValue.getBytes(), md5To16.getBytes());
        char[] chars = DigestUtils.encodeHex1(bytes);

        return new String(chars);
    }

    /**
             * 获取商户交易号
     *
     * @return
     */
    public static String getOutTradeNo() {

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

        return "demo"+"_"+sdf.format(new Date()) +"_"+idGen.getAndIncrement();
    }
    
    /**
             * 获取交易时间
     *
     * @return
     */
    public static String getOutTradeTime() {

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        return sdf.format(new Date());
    }
    
    /**
             * 获取请求序列号
     *
     * @return
     */
    public static String getReqSeqNo() {
        
        return UUID.randomUUID().toString().replace("-", "");
    }

}
