package com.mideaepay.demo.utils;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.http.Header;

import com.mideaepay.demo.model.resp.HttpResponse;

/**
 * 特别声明：demo代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写，并非一定要使用该代码。该代码仅供参考！！！
 */
public class WebUtils {
    
    public static String buildForm(String baseUrl, Map<String, String> parameters) {
        java.lang.StringBuffer sb = new StringBuffer();
        sb.append("<form name=\"pay_form\" method=\"post\" action=\"");
        sb.append(baseUrl);
        sb.append("\">\n");
        sb.append(buildHiddenFields(parameters));
        
        sb.append("<input type=\"submit\" value=\"美的支付\"  style=\"display:none\" >\n");
        sb.append("</form>\n");
        sb.append("<script>document.forms[0].submit();</script>");
        java.lang.String form = sb.toString();
        return form;
    }
    
    private static String buildHiddenFields(Map<String, String> parameters) {
        if (parameters == null || parameters.isEmpty()) {
            return "";
        }
        java.lang.StringBuffer sb = new StringBuffer();
        Set<String> keys = parameters.keySet();
        for (String key : keys) {
            String value = parameters.get(key);
            // 除去参数中的空值
            if (key == null || value == null || value == "") {
                continue;
            }
            sb.append(buildHiddenField(key, value));
        }
        java.lang.String result = sb.toString();
        return result;
    }
    
    private static String buildHiddenField(String key, String value) {
        java.lang.StringBuffer sb = new StringBuffer();
        sb.append("<input type=\"hidden\" name=\"");
        sb.append(key);
        
        sb.append("\" value=\"");
        // 转义双引号
        String a = value.replace("\"", "&quot;");
        sb.append(a).append("\">\n");
        return sb.toString();
    }
    
    public static Map<String, String> getRequestParamsMap(HttpServletRequest req) {
        Map<String, String> map = new TreeMap<>();
        
        Enumeration<String> enumeration = req.getParameterNames();
        while (enumeration.hasMoreElements()) {
            String key = enumeration.nextElement();
            map.put(key, req.getParameter(key));
        }
        return map;
    }
    
    public static void writeHtml(HttpServletResponse resp, String html) {
        try {
            resp.setContentType("text/html; charset=utf-8");
            resp.getWriter().write(html);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    public static void writeJson(HttpServletResponse resp, String html) {
        try {
            resp.setContentType("application/json; charset=utf-8");
            resp.getWriter().write(html);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    /**
             * 获取远程用户ip
     */
    public static String getRemoteIp(HttpServletRequest request) {
        String remoteIp;
        remoteIp = request.getHeader("x-forwarded-for");
        if (remoteIp == null || remoteIp.isEmpty() || "unknown".equalsIgnoreCase(remoteIp)) {
            remoteIp = request.getHeader("X-Real-IP");
        }
        if (remoteIp == null || remoteIp.isEmpty() || "unknown".equalsIgnoreCase(remoteIp)) {
            remoteIp = request.getHeader("Proxy-Client-IP");
        }
        if (remoteIp == null || remoteIp.isEmpty() || "unknown".equalsIgnoreCase(remoteIp)) {
            remoteIp = request.getHeader("WL-Proxy-Client-IP");
        }
        if (remoteIp == null || remoteIp.isEmpty() || "unknown".equalsIgnoreCase(remoteIp)) {
            remoteIp = request.getHeader("HTTP_CLIENT_IP");
        }
        if (remoteIp == null || remoteIp.isEmpty() || "unknown".equalsIgnoreCase(remoteIp)) {
            remoteIp = request.getHeader("HTTP_X_FORWARDED_FOR");
        }
        if (remoteIp == null || remoteIp.isEmpty() || "unknown".equalsIgnoreCase(remoteIp)) {
            remoteIp = request.getRemoteAddr();
        }
        if (remoteIp == null || remoteIp.isEmpty() || "unknown".equalsIgnoreCase(remoteIp)) {
            remoteIp = request.getRemoteHost();
        }
        if (!StringUtils.isEmpty(remoteIp)) {
            String[] arr = remoteIp.split(",");
            for (final String str : arr) {
                if (!"unknown".equalsIgnoreCase(str)) {
                    remoteIp = str;
                    break;
                }
            }
        }
        return remoteIp;
    }
    
    /**
     * @desc <检查是否为json格式的数据>
     * @author kanbo
     * @date 2020-9-5 21:47:08
     * @param httpResp
     */
    public static void checkJson(HttpResponse httpResp) {
        Header[] contentTypes =  httpResp.getContentType();
        int httpCode = httpResp.getHttpCode();
        if(httpCode != 200 ) {
            throw new RuntimeException("httpCode is "+httpCode+", not 200");
        }
        if(contentTypes != null) {
            for(Header contentType : contentTypes) {
                if(contentType.getValue().indexOf("application/json") != -1) {
                   return;
                }
            }
        }
        throw new RuntimeException("http ContentType is not application/json");
    }
    
}
